<?php

/**
 * com_plan_comisionados_objs actions.
 *
 * @package    controlComisiones
 * @subpackage com_plan_comisionados_objs
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class com_plan_comisionados_objsActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_PLAN_COMISIONADOS_OBJS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_PLAN_COMISIONADOS_OBJS_V' =>
        array(
            'num_doc' => 'num_doc',
            'razsoc' => 'razsoc',
            'num_doc,||, - ,||,razsoc' => 'completo_ter',
            'tipter_ter' => 'tipter_ter',
            'tipoter_text' => 'tipoter_text',
            'tipter_ter,||, - ,||,tipoter_text' => 'completo_tipter',
            'codigo' => 'codigo',
            'descripcion' => 'descripcion',
            'nitocc' => 'nitocc',
            'codobj' => 'codobj',
            'id_plan_comisiones' => 'id_plan_comisiones',
            'vigencia' => 'vigencia',
            'valor' => 'valor',
            'estado' => 'estado',
            'observaciones' => 'observaciones',
            'viaticos' => 'viaticos',
            'taxis' => 'taxis',
            'tarifa' => 'tarifa',
            'id_obj_gasto' => 'id_obj_gasto'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'vigencia', 'id_plan_comisiones', 'nitocc', 'codigo'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_PLAN_COMISIONADOS_OBJS_V' =>
        array(
            'num_doc,a' => array('!=' => array(-1)),
            'num_doc,b' => array('=' => array('num_doc')),
            'id_plan_comisiones' => array('=' => array('id_plan_comisiones')),
            'vigencia' => array('=' => array('vigencia')),
            'estado' => array('=' => array('estado')),
            'codobj' => array('=' => array('codobj')),
            'id_obj_gasto' => array('=' => array('id_obj_gasto')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas


    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = null; //identificador de la tabla
    protected $id_names = array('nitocc', 'id_plan_comisiones', 'vigencia', 'codobj'); //llave primaria
    protected $field_names = array('valor', 'estado', 'observaciones',
        'viaticos', 'taxis', 'tarifa', 'id_obj_gasto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_PLAN_COMISIONADOS_OBJS'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_plan_comisiones'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['nitocc'] = $request['num_doc'];
        }

        //accion update
        if ($Action == "UPDATE") {
            $request['nitocc'] = $request['num_doc'];

            //Si es obj gasto 06 toma encuenta valores de liqudiar viaticos
            $id_plan_comisiones = $request['id_plan_comisiones'];
            $vigencia = $request['vigencia'];
            $nitocc = $request['nitocc'];
            $codobj = $request['codobj'];
            $valor = $request['valor'];

            //Se toma por id para verificar si aplica viaticos y no por codigo - 20190801
            if (isset($request['id_obj_gasto'])) {

                $id_obj_gasto = $request['id_obj_gasto'];

                //sentencia sql
                $sql = <<<EOD
SELECT
    *
FROM objetos_gasto
where
id = $id_obj_gasto
and viatico = 1 
EOD;
                //ejecuta el sql
                $records = CN_TABLE::executeSQL($sql);
                if (count($records) > 0) {
                    //$request['valor'] = $request['valor'] + $request['viaticos'] + $request['taxis'];//ya no aplica a viatico - 20210326::LAVILA
                    $request['valor'] = $request['valor'] + $request['viaticos'];
                }


                /**
                 * Incidente #21160, taxis en objeto separado - 20210326::LAVILA
                 */
                $sql = <<<EOD
select valor from com_param_control_comis where parametro = 'CODIGO_OBJETO_TRANSPORTE'   
EOD;
                //ejecuta el sql
                $records = CN_TABLE::executeSQL($sql);
                if (count($records) > 0) {
                    $codigo_objeto_transporte = $records[0]['valor'];

                    $sql = <<<EOD
SELECT
    *
FROM objetos_gasto_v
where
codigo in ( $codigo_objeto_transporte )
and ano_fiscal = $vigencia
order by
codigo desc     
EOD;
                    //ejecuta el sql
                    $records = CN_TABLE::executeSQL($sql);
                    if (count($records) > 0) {
                        $codobj_trans = $records[0]['codigo'];
                        $id_obj_gasto_trans = $records[0]['id'];

                        $request['valor'] = $request['valor'] + $request['taxis'];
                    }
                }
            } else {
                if ($codobj == '06') {
                    $request['valor'] = $request['valor'] + $request['viaticos'] + $request['taxis'];
                }
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            $request['nitocc'] = $request['num_doc'];
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $request['nitocc'] = $request['num_doc'];

        $nitocc = $request['nitocc'];
        $codobj = $request['codobj'];
        $id_plan_comisiones = $request['id_plan_comisiones'];
        $vigencia = $request['vigencia'];

        /*
         *  Generar errores en $errors
         */
        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM com_plan_comisionados_objs
where
nitocc = '$nitocc'
and codobj = '$codobj'
and id_plan_comisiones = $id_plan_comisiones
and vigencia = $vigencia
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {
            $errors['mensaje'] = "El objeto ingresado ya existe para el comisionado.";
            $errors['servicio'] = "com_plan_comisionados_objs";
            $logger->info("El objeto ingresado ya existe para el comisionado.");
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */


        return $errors;
    }

}
